﻿using System.ComponentModel;

namespace ViewModelPair.ViewModels
{
   using System.Windows;

   public class ShellViewModel : INotifyPropertyChanged
   {
      public event PropertyChangedEventHandler PropertyChanged;

      private string firstName;
      private string lastName;

      public ShellViewModel()
      {
         if (DesignerProperties.GetIsInDesignMode(new DependencyObject()))
         {
            this.FirstName = "Foo";
            this.LastName = "Bar";
         }
      }

      /// <summary>
      /// Gets or sets FirstName property
      /// </summary>
      public string FirstName
      {
         get
         {
            return this.firstName;
         }

         set
         {
            if (value != this.firstName)
            {
               this.firstName = value;
               this.OnPropertyChanged("FirstName");
            }
         }
      }

      /// <summary>
      /// Gets or sets LastName property
      /// </summary>
      public string LastName
      {
         get
         {
            return this.lastName;
         }

         set
         {
            if (value != this.lastName)
            {
               this.lastName = value;
               this.OnPropertyChanged("LastName");
            }
         }
      }


      protected void OnPropertyChanged(string propertyName)
      {
         if (this.PropertyChanged != null) this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
      }
   }
}
