// Type: System.ComponentModel.DesignerProperties
// Assembly: System.Windows, Version=2.0.5.0, Culture=neutral, PublicKeyToken=7cec85d7bea7798e
// Assembly location: C:\Program Files (x86)\Reference Assemblies\Microsoft\Framework\Silverlight\v4.0\System.Windows.dll

using System.Security;
using System.Windows;

namespace System.ComponentModel
{
   /// <summary>
   /// Provides attached properties that can be used to communicate with a designer.
   /// </summary>
   public static class DesignerProperties
   {
      /// <summary>
      /// Identifies the <see cref="P:System.ComponentModel.DesignerProperties.IsInDesignMode"/> attached property.
      /// </summary>
      public static readonly DependencyProperty IsInDesignModeProperty;

      private static bool isInDesignTool;
      private static bool s_shouldRefreshOnlyXmlnsDefinitionsOnAssemblyReplace;
      static DesignerProperties();

      internal static bool InternalIsInDesignMode { get; set; }

      /// <summary>
      /// Gets a value that indicates whether the element is running in the context of a designer.
      /// </summary>
      /// 
      /// <returns>
      /// true if the element is running in the context of a designer; otherwise, false.
      /// </returns>
      public static bool IsInDesignTool { get; [SecurityCritical]
      set; }

      public static bool RefreshOnlyXmlnsDefinitionsOnAssemblyReplace { get; [SecurityCritical]
      set; }

      private static void OnIsInDesignModeChanged(object value, DependencyPropertyChangedEventArgs args);

      /// <summary>
      /// Gets the value of the <see cref="P:System.ComponentModel.DesignerProperties.IsInDesignMode"/> attached property for the specified <see cref="T:System.Windows.UIElement"/>.
      /// </summary>
      /// 
      /// <returns>
      /// The <see cref="P:System.ComponentModel.DesignerProperties.IsInDesignMode"/> property value for the element.
      /// </returns>
      /// <param name="element">The element from which the property value is read.</param><exception cref="T:System.ArgumentNullException"><paramref name="element"/> is null.</exception>
      public static bool GetIsInDesignMode(DependencyObject element);

      /// <summary>
      /// Sets the value of the <see cref="P:System.ComponentModel.DesignerProperties.IsInDesignMode"/> attached property to a specified element.
      /// </summary>
      /// <param name="element">The element to which the attached property is written.</param><param name="value">The needed <see cref="T:System.Boolean"/> value.</param><exception cref="T:System.ArgumentNullException"><paramref name="element"/> is null.</exception>
      public static void SetIsInDesignMode(DependencyObject element, bool value);
   }
}
