﻿using System;

namespace DemoIoc.Assets
{
   using System.Collections.Generic;
   using RiaLibrary.Web;

   public class DataProvider : IDataProvider
   {
      readonly NorthwindContext context = new NorthwindContext();


      public void LoadEmployees(Action<IEnumerable<Employee>> callback)
      {
         var query = context.GetEmployeesQuery();
         context.Load(query, lop =>
                               {
                                  if (!lop.HasError)
                                  {
                                     callback(lop.Entities);
                                  }
                                  else
                                  {
                                     //Handle error here...
                                     lop.MarkErrorAsHandled();
                                  }

                               }, null);

      }
   }
}
