﻿
namespace DemoIoc.Services
{
   using System.ComponentModel;
   using Assets;
   using Ninject;
   using Ninject.Modules;
   using ViewModels;

   public class ServiceLocator : NinjectModule, IServiceLocator
   {
      public ServiceLocator()
      {
         this.Kernel = new StandardKernel(this);
      }

      public T Get<T>()
      {
         return this.Kernel.Get<T>();
      }

      public override void Load()
      {
         this.Bind<ShellViewModel>().ToSelf();
         if (DesignerProperties.IsInDesignTool)
         {
            this.Bind<IDataProvider>().To(typeof(DesignTimeProvider));
         }
         else
         {
            this.Bind<IDataProvider>().To(typeof(DataProvider));
         }
      }
   }
}
