﻿using System.Windows;
using GalaSoft.MvvmLight;
using GalaSoft.MvvmLight.Command;

namespace DemoCommands.ViewModels
{
   public class LoginViewModel : ViewModelBase
   {
      private string userName;
      private string password;

      public LoginViewModel()
      {
         this.LoginCommand = new RelayCommand(this.OnLogin, this.CanLogin);
      }

      public RelayCommand LoginCommand { get; private set; }


      public string UserName
      {
         get
         {
            return this.userName;
         }

         set
         {
            if (value != this.userName)
            {
               this.userName = value;
               this.RaisePropertyChanged("UserName");
               this.LoginCommand.RaiseCanExecuteChanged();
            }
         }
      }

      public string Password
      {
         get
         {
            return this.password;
         }

         set
         {
            if (value != this.password)
            {
               this.password = value;
               this.RaisePropertyChanged("Password");
               this.LoginCommand.RaiseCanExecuteChanged();
            }
         }
      }

      private void OnLogin()
      {
         if (this.UserName == "Corrado" && this.Password == "123")
         {
            MessageBox.Show("Welcome!");
         }
         else
         {
            MessageBox.Show("You probably mean 'Corrado' and '123' ;-)");
         }
      }

      private bool CanLogin()
      {
         return !string.IsNullOrEmpty(this.UserName) &&
                 !string.IsNullOrEmpty(this.Password);
      }

   }
}
