﻿
namespace CloseTheWindow.ViewModels
{
   using GalaSoft.MvvmLight;
   using GalaSoft.MvvmLight.Command;
   using GalaSoft.MvvmLight.Messaging;

   public class DetailViewModel : ViewModelBase
   {
      private readonly IMessenger messenger;
      private string text;

      public DetailViewModel(IMessenger messenger)
      {
         this.messenger = messenger;
         this.ChangeInfoCommand = new RelayCommand(this.OnChangeInfo);
      }


      public string Text
      {
         get
         {
            return this.text;
         }

         set
         {
            if (value != this.text)
            {
               this.text = value;
               this.RaisePropertyChanged("Text");
               System.Diagnostics.Debug.WriteLine("Debug:{0}", this.Text);
            }
         }
      }

      public RelayCommand ChangeInfoCommand { get; private set; }

      private void OnChangeInfo()
      {
         this.messenger.Send(this.Text);
      }
   }
}
