﻿
namespace NavigationDemo.Services
{
   using System.Windows;

   /// <summary>
   /// Provides dialog service to ViewModel
   /// </summary>
   public class DialogService : IDialogService
   {
      /// <summary>
      /// Show a dialog box
      /// </summary>
      /// <param name="message">Message to show</param>
      /// <param name="caption">Dialog caption</param>
      /// <param name="button">Dialog button</param>
      /// <returns>User selection</returns>
      public MessageBoxResult ShowMessage(string message, string caption, MessageBoxButton button)
      {
         return MessageBox.Show(message, caption, button);
      }

      /// <summary>
      /// Show a dialog box with default caption and ok button
      /// </summary>
      /// <param name="message">Dialog message</param>
      /// <returns>User selection</returns>
      public MessageBoxResult ShowMessage(string message)
      {
         return this.ShowMessage(message, null, MessageBoxButton.OK);
      }
   }
}
