
namespace NavigationDemo.Services
{
   using System.Windows;

   /// <summary>
   /// Dialog service interface
   /// </summary>
   public interface IDialogService
   {
      /// <summary>
      /// Show a dialog box
      /// </summary>
      /// <param name="message">Message to show</param>
      /// <param name="caption">Dialog caption</param>
      /// <param name="button">Dialog button</param>
      /// <returns>User selection</returns>
      MessageBoxResult ShowMessage(string message, string caption, MessageBoxButton button);

      /// <summary>
      /// Show a dialog box with default caption and ok button
      /// </summary>
      /// <param name="message">Dialog message</param>
      /// <returns>User selection</returns>
      MessageBoxResult ShowMessage(string message);
   }
}