﻿
namespace NavigationDemo.Services
{
   using ViewModels;

   /// <summary>
   /// Provides instances of application viewmodels
   /// </summary>
   public class ViewModelLocator
   {
      /// <summary>
      /// Gets Shell ViewModel
      /// </summary>
      public ShellViewModel ShellViewModel
      {
         get { return this.ServiceLocator.Get<ShellViewModel>(); }
      }

      /// <summary>
      /// Gets Login ViewModel
      /// </summary>
      public LoginViewModel LoginViewModel
      {
         get { return this.ServiceLocator.Get<LoginViewModel>(); }
      }

      /// <summary>
      /// Gets Home ViewModel
      /// </summary>
      public HomeViewModel HomeViewModel
      {
         get { return this.ServiceLocator.Get<HomeViewModel>(); }
      }

      /// <summary>
      /// Gets Administration ViewModel
      /// </summary>
      public AdministrationViewModel AdministrationViewModel
      {
         get { return this.ServiceLocator.Get<AdministrationViewModel>(); }
      }

      /// <summary>
      /// Gets HomeContent ViewModel
      /// </summary>
      public HomeContentViewModel HomeContentViewModel
      {
         get { return this.ServiceLocator.Get<HomeContentViewModel>(); }
      }

      /// <summary>
      /// Gets PreSales ViewModel
      /// </summary>
      public PreSalesViewModel PreSalesViewModel
      {
         get { return this.ServiceLocator.Get<PreSalesViewModel>(); }
      }

      /// <summary>
      /// Gets or sets application service locator
      /// </summary>
      internal IServiceLocator ServiceLocator { get; set; }
   }
}
