﻿
namespace NavigationDemo.ViewModels
{
   using System;
   using GalaSoft.MvvmLight;
   using NavigationDemo.Assets;

   /// <summary>
   /// Base viewmodel that exposes shared application controller 
   /// </summary>
   public abstract class ApplicationViewModelBase : ViewModelBase
   {
      /// <summary>
      /// Initializes a new instance of the NavigationViewModel class
      /// </summary>
      /// <param name="applicationController">Application wide controller</param>
      protected ApplicationViewModelBase(IApplicationController applicationController)
      {
         if (applicationController == null) throw new ArgumentNullException("applicationController");
         this.ApplicationController = applicationController;
      }

      /// <summary>
      /// Gets application controller
      /// </summary>
      protected IApplicationController ApplicationController { get; private set; }
   }
}
