﻿
namespace NavigationDemo.ViewModels
{
   using NavigationDemo.Assets;
   using NavigationDemo.Navigation;
   using NavigationDemo.Services;

   /// <summary>
   /// ViewModel associated with Home page content view
   /// </summary>
   public class HomeContentViewModel : ApplicationViewModelBase, INavigable
   {
      private readonly IDialogService dialogService;

      /// <summary>
      /// Initializes a new instance of the HomeContentViewModel class
      /// </summary>
      /// <param name="applicationController">Global application controller</param>
      public HomeContentViewModel(IApplicationController applicationController)
         : base(applicationController)
      {
      }

      /// <summary>
      /// Gets or sets navigation service that governs applicatin navigation
      /// </summary>
      public INavigationService NavigationService
      {
         get { return this.ApplicationController.NavigationService; }
         set { this.ApplicationController.NavigationService = value; }
      }
   }
}
