﻿
namespace NavigationDemo.ViewModels
{
   using GalaSoft.MvvmLight.Command;
   using NavigationDemo.Assets;
   using NavigationDemo.Navigation;

   public class LoginViewModel : ApplicationViewModelBase, INavigable
   {
      /// <summary>
      /// Initializes a new instance of the LoginViewModel class
      /// </summary>
      /// <param name="applicationController">Application wide controller</param>
      public LoginViewModel(IApplicationController applicationController)
         : base(applicationController)
      {
         this.LoginCommand = new RelayCommand(this.OnLogin);
      }

      /// <summary>
      /// Gets or sets navigation service that governs Shell navigation
      /// </summary>
      public INavigationService NavigationService
      {
         get { return this.ApplicationController.ShellNavigationService; }
         set { this.ApplicationController.ShellNavigationService = value; }
      }

      /// <summary>
      /// Gets Login command
      /// </summary>
      public RelayCommand LoginCommand { get; private set; }

      /// <summary>
      /// Executes LoginCommand
      /// </summary>
      private void OnLogin()
      {
         this.NavigationService.NavigateTo("Home");
      }
   }
}
