﻿using System.Windows;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;

namespace MvvmOnWindowsPhone
{
   using GalaSoft.MvvmLight.Messaging;
   using Services;

   public partial class App : Application
   {
      public PhoneApplicationFrame RootFrame { get; private set; }


      public ViewModelLocator ViewModelLocator
      {
         get
         {
            return (ViewModelLocator)this.Resources["ViewModelLocatorDataSource"];
         }
      }

      public App()
      {
         UnhandledException += Application_UnhandledException;
         InitializeComponent();
         InitializePhoneApplication();

         //Initializes Navigator (here we have the rootframe instantiated...)
         //this.ViewModelLocator.Navigator = new Navigator(this.RootFrame);

         this.ViewModelLocator.Navigator = new NavigationCenter(this.RootFrame, Messenger.Default);
      }

      #region Phone application initialization

      private void RootFrame_NavigationFailed(object sender, NavigationFailedEventArgs e)
      {
         if (System.Diagnostics.Debugger.IsAttached)
         {
            // A navigation has failed; break into the debugger
            System.Diagnostics.Debugger.Break();
         }
      }

      private void Application_UnhandledException(object sender, ApplicationUnhandledExceptionEventArgs e)
      {
         if (System.Diagnostics.Debugger.IsAttached)
         {
            // An unhandled exception has occurred; break into the debugger
            System.Diagnostics.Debugger.Break();
         }
      }


      // Avoid double-initialization
      private bool phoneApplicationInitialized = false;

      // Do not add any additional code to this method
      private void InitializePhoneApplication()
      {
         if (phoneApplicationInitialized)
            return;

         // Create the frame but don't set it as RootVisual yet; this allows the splash
         // screen to remain active until the application is ready to render.
         RootFrame = new PhoneApplicationFrame();
         RootFrame.Navigated += CompleteInitializePhoneApplication;

         // Handle navigation failures
         RootFrame.NavigationFailed += RootFrame_NavigationFailed;

         // Ensure we don't initialize again
         phoneApplicationInitialized = true;
      }

      // Do not add any additional code to this method
      private void CompleteInitializePhoneApplication(object sender, NavigationEventArgs e)
      {
         // Set the root visual to allow the application to render
         if (RootVisual != RootFrame)
            RootVisual = RootFrame;

         // Remove this handler since it is no longer needed
         RootFrame.Navigated -= CompleteInitializePhoneApplication;
      }

      #endregion
   }
}