﻿using System;

namespace MvvmOnWindowsPhone.Services
{
   using Microsoft.Phone.Shell;

   public class Cache : ICache
   {
      public void ToCache(string key, object item)
      {
         if (key == null) throw new ArgumentNullException("key");
         if (item != null) PhoneApplicationService.Current.State[key] = item;
      }

      public T FromCache<T>(string key)
      {
         if (PhoneApplicationService.Current.State.ContainsKey(key))
         {
            T item = (T)PhoneApplicationService.Current.State[key];
            PhoneApplicationService.Current.State.Remove(key);
            return item;
         }
         else
         {
            return default(T);
         }
      }
   }
}
