﻿
namespace MvvmOnWindowsPhone.Services
{
   using GalaSoft.MvvmLight.Messaging;
   using ViewModels;

   public class ViewModelLocator
   {
      private MainViewModel mainViewModel;
      private ShellViewModel shellViewModel;
      private readonly Cache cache = new Cache();
      private readonly IMessenger messenger = Messenger.Default;

      public INavigator Navigator { get; set; }

      public ShellViewModel ShellViewModel
      {
         get
         {
            if (this.shellViewModel == null) this.shellViewModel = new ShellViewModel(this.Navigator, this.messenger);
            return this.shellViewModel;
         }
      }

      public MainViewModel MainViewModel
      {
         get
         {
            if (this.mainViewModel == null) this.mainViewModel = new MainViewModel(this.cache, this.messenger);
            return this.mainViewModel;
         }
      }
   }
}
