﻿
namespace MvvmOnWindowsPhone.ViewModels
{
   using System;
   using System.Windows.Threading;
   using GalaSoft.MvvmLight.Command;
   using GalaSoft.MvvmLight.Messaging;
   using Services;

   public class ShellViewModel : LifeCycleAwareViewModelBase
   {
      private readonly INavigator navigator;
      private readonly DispatcherTimer timer = new DispatcherTimer();
      private string elapsedTime;
      private int count;

      public ShellViewModel(INavigator navigator, IMessenger messenger)
         : base(messenger)
      {
         this.navigator = navigator;
         this.StartCommand = new RelayCommand(this.OnStart);
         this.timer.Interval = TimeSpan.FromSeconds(1);
         this.timer.Tick += new System.EventHandler(this.OnTick);
         this.timer.Start();
      }


      public RelayCommand StartCommand { get; private set; }


      public string ElapsedTime
      {
         get
         {
            return this.elapsedTime;
         }

         set
         {
            if (value != this.elapsedTime)
            {
               this.elapsedTime = value;
               this.RaisePropertyChanged("ElapsedTime");
            }
         }
      }

      private void OnStart()
      {
         this.navigator.Navigate("/Views/Main.xaml");
      }

      private void OnTick(object sender, System.EventArgs e)
      {
         this.ElapsedTime = (this.count++).ToString();
      }
   }
}
