﻿using System.Windows.Controls;
using System.Windows.Input;
using Microsoft.Phone.Controls;

namespace MvvmOnWindowsPhone.Views
{
   using GalaSoft.MvvmLight.Messaging;
   using Messages;

   public partial class Main : PhoneApplicationPage
   {
      public Main()
      {
         InitializeComponent();

         //Registers QueryActiveControl message returning focused control name
         //or setting focus to provided control name
         Messenger.Default.Register<QueryActiveControlMessage>(this, (message) =>
                           {
                              if (message.IsReadMode)
                              {
                                 Control focusedElement = FocusManager.GetFocusedElement() as Control;
                                 message.Name = focusedElement != null
                                                   ? focusedElement.Name
                                                   : null;
                              }
                              else
                              {
                                 Control focusedElement = this.FindName(message.Name) as Control;
                                 focusedElement.Focus();
                              }
                           });
      }
   }
}